package cn.ibizlab.core.rule.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.core.rule.domain.RuleItem;
import cn.ibizlab.core.rule.filter.RuleItemSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[RuleItem] 服务对象接口
 */
public interface IRuleItemService extends IService<RuleItem> {

    boolean create(RuleItem et);
    void createBatch(List<RuleItem> list);
    boolean update(RuleItem et);
    void updateBatch(List<RuleItem> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    RuleItem get(String key);
    RuleItem getDraft(RuleItem et);
    RuleItem buildRuleFile(RuleItem et);
    boolean buildRuleFileBatch(List<RuleItem> etList);
    boolean checkKey(RuleItem et);
    RuleItem modelchange(RuleItem et);
    boolean modelchangeBatch(List<RuleItem> etList);
    boolean save(RuleItem et);
    void saveBatch(List<RuleItem> list);
    Page<RuleItem> searchDefault(RuleItemSearchContext context);
    List<RuleItem> selectByModelId(String id);
    void removeByModelId(String id);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


